--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_mem.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_mem.c	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,842 @@
+/* Name: mausb_mem.c 
+ * Description: Handles all of the dynamic data structures for the host 
+ * controller, including any data that needs to exist 
+ * on a per-device, per-endpoint, or per-transfer basis. 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+ 
+#include <linux/slab.h> 
+#include <linux/usb.h> 
+#include <linux/kthread.h> 
+ 
+#include "mausb_mem.h" 
+#include "mausb_mgmt.h" 
+#include "mausb_tx.h" 
+#include "mausb_pkt.h" 
+#include "mausb_const.h" 
+#include "mausb_hcd.h" 
+ 
+struct mausb_host_ep *mausb_state_to_ep(struct mausb_ep_state *state) 
+{ 
+ return container_of(state, struct mausb_host_ep, state); 
+} 
+EXPORT_SYMBOL(mausb_state_to_ep); 
+ 
+struct mausb_hcd *mausb_host_ep_to_mahcd(struct mausb_host_ep *ep) 
+{ 
+ return ep->mausb_dev->ma_dev->mhcd; 
+} 
+EXPORT_SYMBOL(mausb_host_ep_to_mahcd); 
+ 
+struct mausb_udc *mausb_host_ep_to_maudc(struct mausb_host_ep *ep) 
+{ 
+ return ep->mausb_dev->ma_dev->maudc; 
+} 
+EXPORT_SYMBOL(mausb_host_ep_to_maudc); 
+ 
+struct ma_dev *context_to_ma_dev(void *context) 
+{ 
+ return (struct ma_dev *) context; 
+} 
+ 
+/* 
+ * Finds the media-agnostic data for a given device. 
+ * 
+ * @ma_dev: The MA USB device the USB device is located behind. 
+ * @dev: The USB device to find. 
+ * @handle: The MA USB device handle of USB device to find. 
+ * @gadget: The USB gadget device to find. 
+ * 
+ * Returns a pointer to the media agnostic data for a USB device given one or 
+ * more parameters. Returns NULL if the device cannot be found. 
+ */ 
+struct mausb_dev *mausb_find_dev(struct ma_dev *ma_dev, 
+ struct usb_device *dev, unsigned long *handle, 
+ struct usb_gadget *gadget) 
+{ 
+ struct mausb_dev *mausb_dev; 
+ unsigned long irq_flags; 
+ 
+ spin_lock_irqsave(&ma_dev->ma_dev_lock, irq_flags); 
+ list_for_each_entry(mausb_dev, &ma_dev->dev_list, dev_list) { 
+ 
+ /* if found */ 
+ if ((NULL != dev && mausb_dev->dev == dev) || 
+ (NULL != gadget && mausb_dev->gadget == gadget) || 
+ (NULL != handle && mausb_dev->dev_handle == *handle)) { 
+ spin_unlock_irqrestore(&ma_dev->ma_dev_lock, irq_flags); 
+ return mausb_dev; 
+ } 
+ } 
+ spin_unlock_irqrestore(&ma_dev->ma_dev_lock, irq_flags); 
+ 
+ /* device not found */ 
+ return NULL; 
+} 
+ 
+struct mausb_dev *mausb_find_dev_host(struct ma_dev *ma_dev, 
+ struct usb_device *dev) 
+{ 
+ return mausb_find_dev(ma_dev, dev, NULL, NULL); 
+} 
+EXPORT_SYMBOL(mausb_find_dev_host); 
+ 
+/** 
+ * Returns true if usb_endpoint descriptors are the same. 
+ */ 
+static bool mausb_ep_desc_eq(const struct usb_endpoint_descriptor *desc1, 
+ const struct usb_endpoint_descriptor *desc2) 
+{ 
+ return ((desc1->bLength == desc2->bLength) 
+ && (desc1->bDescriptorType == desc2->bDescriptorType) 
+ && (desc1->bEndpointAddress == desc2->bEndpointAddress) 
+ && (desc1->bmAttributes == desc2->bmAttributes) 
+ && (desc1->wMaxPacketSize == desc2->wMaxPacketSize)); 
+} 
+ 
+/** 
+ * Finds the media agnostic data for an endpoint given one or more parameters. 
+ * 
+ * @ep: USB host endpoint to find MA USB endpoint for. 
+ * @dev_ep: USB device endpoint to find MA USB endpoint for. 
+ * @handle: Endpoint handle of MA USB endpoint. 
+ * @mausb_dev: The MA USB device the endpoint belongs to. 
+ * @ep_desc: endpoint descriptor for USB endpoint. 
+ * @address: MA USB endpoint address. 
+ * 
+ * Returns a pointer to the media agnostic data for the endpoint or NULL if 
+ * the device cannot be found. 
+ */ 
+static struct mausb_host_ep *mausb_find_ep(struct usb_host_endpoint *ep, 
+ struct usb_ep *dev_ep, struct mausb_ep_handle *handle, 
+ struct mausb_dev *mausb_dev, 
+ const struct usb_endpoint_descriptor *ep_desc, 
+ u8 address) 
+{ 
+ struct mausb_host_ep *ma_ep; 
+ unsigned long irq_flags; 
+ 
+ spin_lock_irqsave(&mausb_dev->dev_lock, irq_flags); 
+ list_for_each_entry(ma_ep, &mausb_dev->ep_list, ep_list) { 
+ 
+ /* if found */ 
+ if ((NULL != dev_ep && ma_ep->dev_ep == dev_ep) || 
+ (NULL != ep && ma_ep->ep == ep) || 
+ (NULL != handle 
+ && ma_ep->ep_handle_state != MAUSB_EP_HANDLE_UNASSIGNED 
+ && ma_ep->ep_handle.handle == handle->handle) || 
+ (NULL != ep_desc && NULL != ma_ep->ep 
+ && mausb_ep_desc_eq(ep_desc, &ma_ep->ep->desc)) || 
+ (NULL != ep_desc && NULL != ma_ep->dev_ep && 
+ NULL != ma_ep->dev_ep->desc 
+ && mausb_ep_desc_eq(ep_desc, ma_ep->dev_ep->desc)) || 
+ (address != 0 && NULL != ma_ep->dev_ep && 
+ address == ma_ep->dev_ep->address)) { 
+ 
+ spin_unlock_irqrestore(&mausb_dev->dev_lock, irq_flags); 
+ return ma_ep; 
+ } 
+ } 
+ 
+ spin_unlock_irqrestore(&mausb_dev->dev_lock, irq_flags); 
+ 
+ /* endpoint not found */ 
+ return NULL; 
+} 
+ 
+struct mausb_host_ep *mausb_find_ep_dev(struct usb_ep *dev_ep, 
+ struct mausb_dev *mausb_dev) 
+{ 
+ return mausb_find_ep(NULL, dev_ep, NULL, mausb_dev, NULL, 0); 
+} 
+EXPORT_SYMBOL(mausb_find_ep_dev); 
+ 
+struct mausb_host_ep *mausb_find_ep_host(struct usb_host_endpoint *ep, 
+ struct mausb_dev *mausb_dev) 
+{ 
+ return mausb_find_ep(ep, NULL, NULL, mausb_dev, NULL, 0); 
+} 
+EXPORT_SYMBOL(mausb_find_ep_host); 
+ 
+struct mausb_host_ep *mausb_find_ep_by_desc( 
+ const struct usb_endpoint_descriptor *ep_desc, 
+ struct mausb_dev *mausb_dev) 
+ 
+{ 
+ return mausb_find_ep(NULL, NULL, NULL, mausb_dev, ep_desc, 0); 
+} 
+EXPORT_SYMBOL(mausb_find_ep_by_desc); 
+ 
+struct mausb_host_ep *mausb_find_ep_by_handle(struct mausb_ep_handle *handle, 
+ struct mausb_dev *mausb_dev) 
+{ 
+ return mausb_find_ep(NULL, NULL, handle, mausb_dev, NULL, 0); 
+} 
+EXPORT_SYMBOL(mausb_find_ep_by_handle); 
+ 
+struct mausb_host_ep *mausb_find_ep_by_address(u8 address, 
+ struct mausb_dev *mausb_dev) 
+ 
+{ 
+ return mausb_find_ep(NULL, NULL, NULL, mausb_dev, NULL, address); 
+} 
+EXPORT_SYMBOL(mausb_find_ep_by_address); 
+ 
+struct mausb_host_ep *mausb_find_ep_from_handle(struct mausb_ep_handle handle, 
+ struct ma_dev *ma_dev) 
+{ 
+ struct mausb_host_ep *ma_ep; 
+ struct mausb_dev *mausb_dev; 
+ unsigned long irq_flags; 
+ 
+ spin_lock_irqsave(&ma_dev->ma_dev_lock, irq_flags); 
+ list_for_each_entry(mausb_dev, &ma_dev->dev_list, dev_list) { 
+ spin_unlock_irqrestore(&ma_dev->ma_dev_lock, irq_flags); 
+ 
+ ma_ep = mausb_find_ep_by_handle(&handle, mausb_dev); 
+ if (ma_ep != NULL) 
+ return ma_ep; 
+ 
+ spin_lock_irqsave(&ma_dev->ma_dev_lock, irq_flags); 
+ } 
+ spin_unlock_irqrestore(&ma_dev->ma_dev_lock, irq_flags); 
+ 
+ return NULL; 
+} 
+ 
+/** 
+ * Wrapper function to be used by devices when they want to generate an 
+ * ma packet. 
+ */ 
+struct mausb_pkt *mausb_pkt_from_ms_pkt_ma_dev(struct ms_pkt *ms_pkt, 
+ struct ma_dev *ma_dev, gfp_t mem_flags) 
+{ 
+ return mausb_pkt_from_ms_pkt(ms_pkt, 
+ ma_dev->ms_driver->ops->pkt_destructor, mem_flags); 
+} 
+EXPORT_SYMBOL(mausb_pkt_from_ms_pkt_ma_dev); 
+ 
+/** 
+ * Wrapper to be used by endpoints when they want to generate an ma packet. 
+ */ 
+struct mausb_pkt *mausb_pkt_from_ms_pkt_ep(struct ms_pkt *ms_pkt, 
+ struct mausb_host_ep *ep, gfp_t mem_flags) 
+{ 
+ return mausb_pkt_from_ms_pkt_ma_dev(ms_pkt, ep->mausb_dev->ma_dev, 
+ mem_flags); 
+} 
+EXPORT_SYMBOL(mausb_pkt_from_ms_pkt_ep); 
+ 
+const struct usb_endpoint_descriptor *mausb_get_ep_des( 
+ struct mausb_host_ep *ma_ep) 
+{ 
+ if ((NULL != ma_ep->ep && NULL != ma_ep->dev_ep) || 
+ (NULL == ma_ep->ep && NULL == ma_ep->dev_ep)) { 
+ 
+ mamem_err("%s: ERROR: ep = 0x%p, dev_ep = 0x%p " 
+ "(only one should be set)\n", __func__, 
+ ma_ep->ep, ma_ep->dev_ep); 
+ 
+ return NULL; 
+ } 
+ 
+ if (NULL != ma_ep->ep) 
+ return &ma_ep->ep->desc; 
+ 
+ if (NULL != ma_ep->dev_ep) 
+ return ma_ep->dev_ep->desc; 
+ 
+ /* We should never get here */ 
+ BUG(); 
+ return NULL; 
+} 
+EXPORT_SYMBOL(mausb_get_ep_des); 
+ 
+/** 
+ * Fills an MA USB packet header for the given maurb 
+ */ 
+static int fill_mausb_dph(struct mausb_dph *ma_pkt, struct mausb_urb *maurb, 
+ bool in, bool host) 
+{ 
+ const struct usb_endpoint_descriptor *ep_des; 
+ unsigned long irq_flags; 
+ 
+ /* set the version number */ 
+ ma_pkt->common.ver_flags = MAUSB_VERSION_1_0 & MAUSB_VERSION_MASK; 
+ 
+ /* set the host flag if from the host */ 
+ ma_pkt->common.ver_flags |= host ? MAUSB_PKT_FLAG_HOST : 0; 
+ 
+ /* set the device handle field */ 
+ spin_lock_irqsave(&maurb->ep->ep_lock, irq_flags); 
+ ma_pkt->common.ep_handle = maurb->ep->ep_handle; 
+ spin_unlock_irqrestore(&maurb->ep->ep_lock, irq_flags); 
+ 
+ ma_pkt->common.pkt_status = SUCCESS; 
+ 
+ ep_des = mausb_get_ep_des(maurb->ep); 
+ 
+ /* set transfer type in tflags field */ 
+ switch (usb_endpoint_type(ep_des)) { 
+ case USB_ENDPOINT_XFER_CONTROL: 
+ ma_pkt->eps_tflags |= MAUSB_PKT_TFLAG_TYPE_CTRL; 
+ break; 
+ case USB_ENDPOINT_XFER_ISOC: 
+ ma_pkt->eps_tflags |= MAUSB_PKT_TFLAG_TYPE_ISOC; 
+ break; 
+ case USB_ENDPOINT_XFER_BULK: 
+ ma_pkt->eps_tflags |= MAUSB_PKT_TFLAG_TYPE_BULK; 
+ break; 
+ case USB_ENDPOINT_XFER_INT: 
+ ma_pkt->eps_tflags |= MAUSB_PKT_TFLAG_TYPE_INT; 
+ break; 
+ default: 
+ mamem_err("%s: invalid transfer type\n", __func__); 
+ } 
+ 
+ return 0; 
+} 
+ 
+/** 
+ * Create a datapacket from a given URB. 
+ */ 
+struct mausb_pkt *mausb_create_dp(int *status, struct mausb_urb *maurb, 
+ bool in, bool host, gfp_t memflags) 
+{ 
+ struct mausb_pkt *pkt; 
+ int ret = 0; 
+ 
+ pkt = mausb_alloc_pkt(MAUSB_PKT_TYPE_DATA, status, memflags); 
+ if (NULL == pkt) { 
+ mamem_err("%s:failed to allocate memory for mausb packet\n", 
+ __func__); 
+ 
+ if (NULL != status) 
+ *status = -ENOMEM; 
+ 
+ return NULL; 
+ } 
+ 
+ ret = fill_mausb_dph(pkt->data, maurb, in, host); 
+ INIT_LIST_HEAD(&pkt->pkt_list); 
+ if (NULL != status) 
+ *status = ret; 
+ 
+ return pkt; 
+} 
+EXPORT_SYMBOL(mausb_create_dp); 
+ 
+struct mausb_urb *mausb_alloc_maurb(struct mausb_host_ep *ma_ep, gfp_t memflags) 
+{ 
+ struct mausb_urb *maurb; 
+ 
+ maurb = kzalloc(sizeof(struct mausb_urb), memflags); 
+ if (!maurb) 
+ return NULL; 
+ 
+ INIT_LIST_HEAD(&maurb->urb_list); 
+ maurb->ep = ma_ep; 
+ maurb->dev = ma_ep->mausb_dev; 
+ 
+ return maurb; 
+} 
+EXPORT_SYMBOL(mausb_alloc_maurb); 
+ 
+/** 
+ * Deletes the given maurb and removes all pointers to it from memory. 
+ */ 
+int mausb_internal_drop_maurb(struct mausb_urb *maurb, struct mausb_hcd *mhcd) 
+{ 
+ struct mausb_host_ep *ep = maurb->ep; 
+ unsigned long irq_flags; 
+ 
+ spin_lock_irqsave(&ep->ep_lock, irq_flags); 
+ 
+ list_del(&maurb->urb_list); 
+ if (maurb == ep->active_transfer) 
+ ep->active_transfer = NULL; 
+ 
+ spin_unlock_irqrestore(&ep->ep_lock, irq_flags); 
+ 
+ spin_lock_irqsave(&mhcd->urb_list_lock, irq_flags); 
+ list_del(&maurb->ma_hcd_urb_list); 
+ spin_unlock_irqrestore(&mhcd->urb_list_lock, irq_flags); 
+ 
+ /* 
+ * Nobody else should know this maurb exists, so it should be 
+ * safe to free 
+ */ 
+ kfree(maurb); 
+ 
+ return 0; 
+} 
+EXPORT_SYMBOL(mausb_internal_drop_maurb); 
+ 
+/** 
+ * Sets endpoint state to default. 
+ * 
+ * @state: State of endpoint to be configured. 
+ * @buf_size: The maximum number of Bytes the device-side buffer 
+ * can receive from the host. 
+ * 
+ * Called whenever an MA USB endpoint is configured and needs to be set 
+ * or reset to its initial state. 
+ */ 
+void init_ep_state(struct mausb_ep_state *state, u32 buf_size) 
+{ 
+ state->request_id = 0; 
+ state->active_request_id = 0; 
+ state->seq_number = 0; 
+ state->tx_pending = 0; 
+ state->earliest_request_id = 0; 
+ state->earliest_unacked = 0; 
+ state->occupancy = 0; 
+ state->rx_buf_size = buf_size; 
+ state->keep_alive_timer = MAUSB_TRANSFER_KEEP_ALIVE; 
+ state->retry_counter = MAUSB_BULK_TRANSFER_RETRIES; 
+ /* TODO: number of retries depends on transfer type, include 
+ * other transfer types (control and interrupt) */ 
+} 
+ 
+struct mausb_gadget_ep *usb_ep_to_mausb_gadget_ep(struct usb_ep *ep) 
+{ 
+ return container_of(ep, struct mausb_gadget_ep, dev_ep); 
+} 
+EXPORT_SYMBOL(usb_ep_to_mausb_gadget_ep); 
+ 
+/** 
+ * Links a Device-side endpoint to an MA USB endpoint 
+ */ 
+void mausb_link_ma_ep_to_usb_ep(struct mausb_host_ep *ma_ep, 
+ struct usb_ep *dev_ep) 
+{ 
+ struct mausb_gadget_ep *gadget_ep = usb_ep_to_mausb_gadget_ep(dev_ep); 
+ 
+ ma_ep->dev_ep = dev_ep; 
+ ma_ep->halted = 0; 
+ ma_ep->wedged = 0; 
+ 
+ ma_ep->usb_req_list = &gadget_ep->usb_req_list; 
+} 
+EXPORT_SYMBOL(mausb_link_ma_ep_to_usb_ep); 
+ 
+/* 
+ * Adds an endpoint to the specified device. 
+ * 
+ * @ma_dev: The usb device to add the endpoint to. 
+ * @ep/dev_ep: The usb struct for the endpoint being added. 
+ * Note: give only one of the endpoint pointers and 
+ * set the other to NULL. 
+ * @mausb_ep: The mausb_ep struct created by this function. 
+ * @transfer_timeout: The transfer timeout function. A thread will be 
+ * spawned with this function for handling timeouts. 
+ * 
+ * Adds the given endpoint to the given device. The difference between this 
+ * function and mausb_add_endpoint (which can be called from the usb core) 
+ * is that this uses the private ma-structs. Calling this function is 
+ * cheaper, and therefore preferred when possible, since mausb_add_endpoint 
+ * will have to find the internal structures. 
+ */ 
+int mausb_internal_add_ep(struct mausb_dev *ma_dev, 
+ struct usb_host_endpoint *ep, struct usb_ep *dev_ep, 
+ struct mausb_host_ep **mausb_ep, 
+ int (*transfer_timeout)(void *data), gfp_t memflags) 
+{ 
+ struct mausb_host_ep *ma_ep; 
+ unsigned long irq_flags; 
+ 
+ ma_ep = kzalloc(sizeof(struct mausb_host_ep), memflags); 
+ if (!ma_ep) 
+ return -ENOMEM; 
+ 
+ /* host operations */ 
+ if (ep != NULL) { 
+ ep->hcpriv = ma_ep; 
+ ma_ep->ep = ep; 
+ 
+ /* device operations */ 
+ } else if (dev_ep != NULL) 
+ mausb_link_ma_ep_to_usb_ep(ma_ep, dev_ep); 
+ 
+ ma_ep->mausb_dev = ma_dev; 
+ 
+ /* set initial EP State */ 
+ init_ep_state(&ma_ep->state, DEVICE_RX_BUF_SIZE); 
+ 
+ /* 
+ * only used by full speed devices to determine if the max packet 
+ * size has changed for EP0 
+ */ 
+ ma_ep->max_pkt = 8; 
+ 
+ /* initialize mausb_ep_handle */ 
+ ma_ep->ep_handle_state = MAUSB_EP_HANDLE_UNASSIGNED; 
+ 
+ INIT_LIST_HEAD(&ma_ep->urb_list); 
+ INIT_LIST_HEAD(&ma_ep->ep_list); 
+ INIT_LIST_HEAD(&ma_ep->req_list); 
+ INIT_LIST_HEAD(&ma_ep->resp_list); 
+ 
+ spin_lock_init(&ma_ep->ep_lock); 
+ ma_ep->tx_timed_out = false; 
+ 
+ /* initialize endpoint work queue */ 
+ init_waitqueue_head(&ma_ep->host_ep_wq); 
+ 
+ /* initialize endpoint timer */ 
+ setup_timer(&ma_ep->timer, wake_timeout_thread, (unsigned long) ma_ep); 
+ 
+ /* add the endpoint to the device */ 
+ spin_lock_irqsave(&ma_dev->dev_lock, irq_flags); 
+ list_add_tail(&ma_ep->ep_list, &ma_dev->ep_list); 
+ spin_unlock_irqrestore(&ma_dev->dev_lock, irq_flags); 
+ 
+ /* give a pointer to the ma_ep back to the caller */ 
+ if (NULL != mausb_ep) 
+ *mausb_ep = ma_ep; 
+ 
+ return 0; 
+} 
+EXPORT_SYMBOL(mausb_internal_add_ep); 
+ 
+/** 
+ * Drops the given endpoint from the given device. The difference between this 
+ * function and mausb_drop_endpoint (which can be called from the usb core) 
+ * is that this uses the private ma-structs. Calling this function is 
+ * cheaper, and therefore preferred when possible, since mausb_drop_endpoint 
+ * will have to find the internal endpoint structure. 
+ */ 
+int mausb_internal_drop_ep(struct mausb_host_ep *ma_ep) 
+{ 
+ struct mausb_dev *ma_dev; 
+ struct mausb_request *ma_request, *next_request; 
+ struct mausb_pkt *ma_pkt, *next_pkt; 
+ unsigned long irq_flags; 
+ unsigned long irq_flags2; 
+ 
+ if (NULL == ma_ep) 
+ return -EINVAL; 
+ 
+ /* drop all pending transfers */ 
+ spin_lock_irqsave(&ma_ep->ep_lock, irq_flags); 
+ ma_dev = ma_ep->mausb_dev; 
+ 
+ /* stop transfer timeout thread */ 
+ if (NULL != ma_ep->timeout_task) 
+ kthread_stop(ma_ep->timeout_task); 
+ 
+ /* drop all pending usb_requests (if there are any) */ 
+ if (NULL != ma_ep->usb_req_list) { 
+ list_for_each_entry_safe(ma_request, next_request, 
+ ma_ep->usb_req_list, usb_req_list) { 
+ list_del(&ma_request->usb_req_list); 
+ ma_request->req.status = -ESHUTDOWN; 
+ ma_request->req.complete(ma_ep->dev_ep, 
+ &ma_request->req); 
+ } 
+ } 
+ 
+ /* flush out all of the stored request/response packets */ 
+ list_for_each_entry_safe(ma_pkt, next_pkt, &ma_ep->req_list, pkt_list) { 
+ list_del(&ma_pkt->pkt_list); 
+ mausb_free_pkt(ma_pkt); 
+ } 
+ list_for_each_entry_safe(ma_pkt, next_pkt, 
+ &ma_ep->resp_list, pkt_list) { 
+ list_del(&ma_pkt->pkt_list); 
+ mausb_free_pkt(ma_pkt); 
+ } 
+ 
+ /* remove the endpoint from the list */ 
+ spin_lock_irqsave(&ma_dev->dev_lock, irq_flags2); 
+ list_del(&ma_ep->ep_list); 
+ spin_unlock_irqrestore(&ma_dev->dev_lock, irq_flags2); 
+ 
+ spin_unlock_irqrestore(&ma_ep->ep_lock, irq_flags); 
+ 
+ kfree(ma_ep); 
+ 
+ return 0; 
+} 
+EXPORT_SYMBOL(mausb_internal_drop_ep); 
+ 
+/** 
+ * Updates the state of an endpoint based on the mausb_ep_des. 
+ */ 
+int mausb_update_ep(struct mausb_host_ep *ma_ep, 
+ struct mausb_ep_des *ma_ep_des) 
+{ 
+ unsigned long irq_flags; 
+ 
+ spin_lock_irqsave(&ma_ep->ep_lock, irq_flags); 
+ 
+ if (!ma_ep_des->valid) { /* Valid bit: 0 means valid */ 
+ ma_ep->ep_handle.handle = ma_ep_des->ep_handle.handle; 
+ ma_ep->ep_handle_state = MAUSB_EP_HANDLE_ACTIVE; 
+ } 
+ 
+ if (ma_ep_des->dir == 0) { 
+ ma_ep->state.rx_buf_size = ma_ep_des->buffer_size; 
+ 
+ 
+ if (ma_ep_des->l_man) 
+ ma_ep->lman_support = true; 
+ else 
+ ma_ep->lman_support = false; 
+ } 
+ 
+ /*TODO: parse and use the remainder of the values in the packet */ 
+ 
+ spin_unlock_irqrestore(&ma_ep->ep_lock, irq_flags); 
+ 
+ return 0; 
+} 
+ 
+/** 
+ * Allocates private per-usb-device data. 
+ * 
+ * @ma_dev: The MA USB device to which the USB device belongs 
+ * @usb_dev: The host-side USB device struct to add. 
+ * @gadget: The device-side USB device struct to add. 
+ * 
+ * This function allocates a new device and adds it onto the MA USB device's 
+ * linked list of usb devices. It also allocates endpoint data for the control 
+ * endpoint (EP0). 
+ */ 
+struct mausb_dev *mausb_internal_alloc_dev(struct ma_dev *ma_dev, 
+ struct usb_device *dev, struct usb_gadget *gadget) 
+{ 
+ unsigned long irq_flags; 
+ struct mausb_dev *mausb_dev; 
+ 
+ mausb_dev = kzalloc(sizeof(struct mausb_dev), GFP_KERNEL); 
+ 
+ if (!mausb_dev) 
+ return NULL; 
+ 
+ if (NULL != dev) 
+ mausb_dev->dev = dev; 
+ if (NULL != gadget) 
+ mausb_dev->gadget = gadget; 
+ mausb_dev->ma_dev = ma_dev; 
+ INIT_LIST_HEAD(&mausb_dev->ep_list); 
+ INIT_LIST_HEAD(&mausb_dev->dev_list); 
+ spin_lock_init(&mausb_dev->dev_lock); 
+ 
+ spin_lock_irqsave(&ma_dev->ma_dev_lock, irq_flags); 
+ 
+ /* 
+ * If this is the first device to be allocated, then it should be the 
+ * most upstream. 
+ */ 
+ if (NULL == ma_dev->top_dev) 
+ ma_dev->top_dev = mausb_dev; 
+ 
+ list_add_tail(&mausb_dev->dev_list, &ma_dev->dev_list); 
+ spin_unlock_irqrestore(&ma_dev->ma_dev_lock, irq_flags); 
+ 
+ return mausb_dev; 
+} 
+EXPORT_SYMBOL(mausb_internal_alloc_dev); 
+ 
+/** 
+ * Frees private per-device data. 
+ * 
+ * @ma_dev: The MA USB device that the USB device beingfreed belongs to. 
+ * @mausb_dev: The MA USB data associated with the USB device being freed. 
+ * 
+ * This function removes a USB device from the MA USB hcd's linked list 
+ * and releases the device's media agnostic data structure. All endpoints 
+ * belonging to this device are also removed from the MA USB hcd and released 
+ * (including EP0). 
+ */ 
+int mausb_internal_free_dev(struct ma_dev *ma_dev, struct mausb_dev *mausb_dev) 
+{ 
+ int ret = 0; 
+ unsigned long irq_flags, irq_flags2; 
+ struct mausb_host_ep *ma_ep, *next; 
+ 
+ /* remove all the endpoints from the device */ 
+ spin_lock_irqsave(&mausb_dev->dev_lock, irq_flags); 
+ list_for_each_entry_safe(ma_ep, next, &mausb_dev->ep_list, ep_list) { 
+ spin_unlock_irqrestore(&mausb_dev->dev_lock, irq_flags); 
+ ret = mausb_internal_drop_ep(ma_ep); 
+ 
+ spin_lock_irqsave(&mausb_dev->dev_lock, irq_flags); 
+ } 
+ 
+ if (!list_empty(&mausb_dev->ep_list)) { 
+ spin_unlock_irqrestore(&mausb_dev->dev_lock, irq_flags); 
+ return ret; 
+ } 
+ 
+ /* remove the mausb device from the ma device */ 
+ spin_lock_irqsave(&ma_dev->ma_dev_lock, irq_flags2); 
+ list_del(&mausb_dev->dev_list); 
+ 
+ /* if the top device is being removed */ 
+ if (ma_dev->top_dev == mausb_dev) 
+ ma_dev->top_dev = NULL; 
+ 
+ spin_unlock_irqrestore(&ma_dev->ma_dev_lock, irq_flags2); 
+ 
+ spin_unlock_irqrestore(&mausb_dev->dev_lock, irq_flags); 
+ 
+ kfree(mausb_dev); 
+ 
+ return ret; 
+ 
+} 
+EXPORT_SYMBOL(mausb_internal_free_dev); 
+ 
+/** 
+ * Resets all the data in a ma_dev struct. This includes freeing all the MA 
+ * data for the usb devices and endpoints connected to this device. 
+ */ 
+int mausb_internal_reset_ma_dev(struct ma_dev *ma_dev, __u8 ma_dev_addr, 
+ __u8 mass_id, struct mausb_hcd *mhcd, struct mausb_udc *maudc) 
+{ 
+ int ret = -EINVAL; 
+ struct mausb_dev *mausb_dev, *mausb_next; 
+ int (*req_switch)(struct mausb_mgmt_pkt *req, 
+ struct mausb_mgmt_pkt *resp, 
+ struct mausb_mgmt *mgmt) 
+ = ma_dev->mgmt.req_switch; 
+ int (*device_connect)(int) = ma_dev->ma_drv.device_connect; 
+ unsigned long irq_flags; 
+ 
+ if (NULL != mhcd) 
+ ma_dev->mhcd = mhcd; 
+ 
+ if (NULL != maudc) 
+ ma_dev->maudc = maudc; 
+ 
+ spin_lock_irqsave(&ma_dev->ma_dev_lock, irq_flags); 
+ list_for_each_entry_safe(mausb_dev, mausb_next, &ma_dev->dev_list, 
+ dev_list) { 
+ spin_unlock_irqrestore(&ma_dev->ma_dev_lock, irq_flags); 
+ 
+ ret = mausb_internal_free_dev(ma_dev, mausb_dev); 
+ 
+ spin_lock_irqsave(&ma_dev->ma_dev_lock, irq_flags); 
+ } 
+ 
+ if (!list_empty(&ma_dev->dev_list)) { 
+ /* could not clear all the devices */ 
+ ret = -EAGAIN; 
+ } 
+ 
+ spin_unlock_irqrestore(&ma_dev->ma_dev_lock, irq_flags); 
+ 
+ /* TODO: make sure this doesn't break any locking rules */ 
+ mausb_init_ma_device(ma_dev, ma_dev_addr, mass_id, mhcd, 
+ maudc, req_switch, device_connect); 
+ 
+ return ret; 
+} 
+ 
+/** 
+ * Initializes the media agnostic management structure. 
+ */ 
+int mausb_init_mgmt(struct mausb_mgmt *mgmt, spinlock_t *ma_dev_lock, 
+ int (*req_switch)(struct mausb_mgmt_pkt *req, 
+ struct mausb_mgmt_pkt *resp, struct mausb_mgmt *mgmt)) 
+{ 
+ INIT_LIST_HEAD(&mgmt->req_list); 
+ mgmt->token = 0; 
+ mgmt->tx_pair.to_ms.context = NULL; 
+ mgmt->tx_pair.to_ms.transfer_packet = NULL; 
+ mgmt->tx_pair.to_ma.context = NULL; 
+ mgmt->tx_pair.to_ma.transfer_packet = NULL; 
+ mgmt->hub_dev_handle = 0; 
+ mgmt->ma_dev_lock = ma_dev_lock; 
+ mgmt->req_switch = req_switch; 
+ 
+ return 0; 
+} 
+ 
+static void mausb_init_pkt_dmux(struct mausb_pkt_transfer *pkt_dmux, 
+ void *context) 
+{ 
+ pkt_dmux->transfer_packet = &mausb_pkt_dmux; 
+ pkt_dmux->context = context; 
+} 
+ 
+/* 
+ * Initializes the data structure for an MA USB device. 
+ */ 
+int mausb_init_ma_device(struct ma_dev *ma_dev, __u8 ma_dev_addr, __u8 mass_id, 
+ struct mausb_hcd *mhcd, struct mausb_udc *maudc, 
+ int (*req_switch)(struct mausb_mgmt_pkt *req, 
+ struct mausb_mgmt_pkt *resp, struct mausb_mgmt *mgmt), 
+ int (*device_connect)(int)) 
+{ 
+ INIT_LIST_HEAD(&ma_dev->dev_list); 
+ ma_dev->top_dev = NULL; 
+ ma_dev->ma_dev_addr = ma_dev_addr; 
+ ma_dev->mass_id = mass_id; 
+ if (mhcd != NULL) 
+ ma_dev->mhcd = mhcd; 
+ if (maudc != NULL) 
+ ma_dev->maudc = maudc; 
+ spin_lock_init(&ma_dev->ma_dev_lock); 
+ ma_dev->ma_drv.device_connect = device_connect; 
+ mausb_init_pkt_dmux(&ma_dev->ma_drv.pkt_dmux, ma_dev); 
+ 
+ mausb_init_mgmt(&ma_dev->mgmt, &ma_dev->ma_dev_lock, req_switch); 
+ 
+ return 0; 
+} 
+EXPORT_SYMBOL(mausb_init_ma_device); 
+ 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_mem.h linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_mem.h
